using System;

namespace Syntriax.Modules.Factory
{
    public interface IFactory
    {
        /// <summary>
        /// If the <see cref="IFactory"/> is initialized
        /// </summary>
        bool IsInitialized { get; }

        /// <summary>
        /// Initializes the <see cref="IFactory"/>
        /// </summary>
        void Initialize();

        /// <summary>
        /// Resets the <see cref="IFactory"/>
        /// </summary>
        void Reset();

        Action<IFactory> OnInitialized { get; set; }
        Action<IFactory> OnReset { get; set; }
        Action<IFactory> OnStateChanged { get; set; }
    }
}
